import openpyxl
from datetime import datetime


def create_excel_result(callback, config):
    # Öffnen Sie eine neue Excel-Arbeitsmappe
    workbook = openpyxl.Workbook()

    # Fügen Sie ein neues Arbeitsblatt hinzu
    worksheet = workbook.create_sheet()

    # Basis Configurationen hier beschreiben
    # TODO: Implementieren der Excluded Folder, Aktivierungsfunktion (128 Einheiten, 1 Einheit), Optimierungsverfahren

    # Schreiben Sie die Überschriften in die erste Zeile
    # TODO: Ergänzung Recall 1, Recall 2
    worksheet.cell(row=1, column=1).value = 'epoch'
    worksheet.cell(row=1, column=2).value = 'loss'
    worksheet.cell(row=1, column=3).value = 'accuracy'
    worksheet.cell(row=1, column=4).value = 'val_loss'
    worksheet.cell(row=1, column=5).value = 'val_accuracy'
    worksheet.cell(row=1, column=6).value = 'duration'

    # Schreiben Sie die Ergebnisse der Epochen in die Arbeitsmappe
    for i, (loss, accuracy, val_loss, val_accuracy, duration) in enumerate(
            zip(callback.epoch_losses, callback.epoch_accuracies, callback.epoch_val_losses,
                callback.epoch_val_accuracies, callback.epoch_durations)):
        worksheet.cell(row=i + 2, column=1).value = i + 1
        worksheet.cell(row=i + 2, column=2).value = loss
        worksheet.cell(row=i + 2, column=3).value = accuracy
        worksheet.cell(row=i + 2, column=4).value = val_loss
        worksheet.cell(row=i + 2, column=5).value = val_accuracy
        worksheet.cell(row=i + 2, column=6).value = duration

    now = datetime.now()
    date_time = now.strftime("%d_%m_%y__%H_%M")
    file_name = "epoch_results_" + date_time + ".xlsx"
    # Speichern Sie die Arbeitsmappe
    workbook.save(config["result"]["excel_path"] + file_name)

    # Abschlussbericht definieren
    # TODO: Implementierung Evaluation mit Excluded Folder, Accuracy, Recall 1, Recall 2


# TODO: Abschluss Statistik nach Cross-Validation von einer Konfiguration: Durchschnitt Accuracy, Recall 1, Recall 2, Loss, Duration für Evaluation
