import tensorflow as tf
import time


class CustomCallback(tf.keras.callbacks.Callback):
    def on_train_begin(self, logs={}):
        self.epoch_losses = []
        self.epoch_accuracies = []
        self.epoch_val_losses = []
        self.epoch_val_accuracies = []
        self.epoch_durations = []

    def on_epoch_begin(self, epoch, logs={}):
        self.epoch_start_time = time.time()

    def on_epoch_end(self, epoch, logs={}):
        self.epoch_losses.append(logs.get('loss'))
        self.epoch_accuracies.append(logs.get('accuracy'))
        self.epoch_val_losses.append(logs.get('val_loss'))
        self.epoch_val_accuracies.append(logs.get('val_accuracy'))
        self.epoch_durations.append(time.time() - self.epoch_start_time)